// Hall_sensor_LCD_display_nn

// this one works
// measuring 240V AC current using ACS712
// The ACS712 works with grid voltage AC so be extremely careful !
// source - /www.circuits4you.com
//
// floris woouterlood - June 10, 2019

#include <LiquidCrystal.h>

const int sensorIn = A0;
int mVperAmp = 185;           // this the 5A version of the SC712 -use 100 for 20A Module and 66 for 30A Module
int Watt = 0;
double Voltage = 0;
double VRMS = 0;
double AmpsRMS = 0;

// initialize the library with the numbers of the interface pins
  LiquidCrystal lcd(12, 11, 5, 4, 3, 2);


void setup() {
  pinMode(6, OUTPUT);
  Serial.begin (9600); 
  Serial.println ("Hall sensor"); 
 
  lcd.begin (20, 4);            // set up the LCD - number of columns, rows
  lcd.clear ();  
  lcd.setCursor (0, 0); 
  lcd.print ("Hall sensor");

  digitalWrite(6, HIGH);   // turn the LED on (HIGH is the voltage level)
     
}

void loop() {

  Serial.println ("");
  
  Voltage = getVPP();
  VRMS = (Voltage/2.0) *0.707;   //root 2 is 0.707
  AmpsRMS = (VRMS * 1000)/mVperAmp;
 
  Serial.print(AmpsRMS);
  Serial.print(" Amps RMS  ---  ");
  Watt = (AmpsRMS*240/1.3);      // 1.3 is an empirical calibration factor
  Serial.print(Watt);
  Serial.println(" W");
 
  lcd_control ();  
 
}


float getVPP()
{
  float result;
  int readValue;                // value read from the sensor
  int maxValue = 0;             // store max value here
  int minValue = 1024;          // store min value here
  
   uint32_t start_time = millis();
   while((millis()-start_time) < 1000) //sample for 1 Sec
   {
       readValue = analogRead(sensorIn);
       // see if you have a new maxValue
       if (readValue > maxValue) 
       {
           /*record the maximum sensor value*/
           maxValue = readValue;
       }
       if (readValue < minValue) 
       {
           /*record the minimum sensor value*/
           minValue = readValue;
       }
   }
   
   // Subtract min from max
   result = ((maxValue - minValue) * 5.0)/1024.0;
      
   return result;
 }

void lcd_control (){

    lcd.setCursor (5, 2);
    lcd.print (Watt); 
    lcd.print (" watt  ");
  
}
  
